
import com.fasterxml.jackson.core.JsonProcessingException;
import com.fasterxml.jackson.databind.ObjectMapper;
import com.mashape.unirest.http.exceptions.UnirestException;

import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStream;
import java.io.InputStreamReader;
import java.util.ArrayList;
import java.util.List;

public class SimpleShell {


    public static void prettyPrint(String output) {
        // yep, make an effort to format things nicely, eh?
        String[] result = output.split("},\\{");
        int counter = 1;
        String newString;
        for (int i = 0; i<result.length; i++) {
            newString = result[i].replaceAll("[,]"," ");
            newString = newString.replaceAll("[\\[{\"\\]}\\\\]","");
            if(newString.startsWith("toid")){
                if(i<20){System.out.println((counter++) + "  " + newString +"\n");}
            } else{
            System.out.println((counter++) + "  " + newString +"\n");}
        }
    }


    public static void main(String[] args) throws java.io.IOException, UnirestException {

        YouAreEll webber = new YouAreEll("http://zipcode.rocks:8085");
        String commandLine;
        BufferedReader console = new BufferedReader
                (new InputStreamReader(System.in));

        ProcessBuilder pb = new ProcessBuilder();
        List<String> history = new ArrayList<String>();
        List<Ids> idList = new ArrayList<>();

        //we break out with <ctrl c>
        while (true) {
            //read what the user enters
            System.out.println("cmd? ");
            commandLine = console.readLine();

            //input parsed into array of strings(command and arguments)
            String[] commands = commandLine.split(" ");
            List<String> list = new ArrayList<String>();

            //if the user entered a return, just loop again
            if (commandLine.equals(""))
                continue;
            if (commandLine.equals("exit")) {
                System.out.println("bye!");
                break;
            }

            //loop through to see if parsing worked
            for (int i = 0; i < commands.length; i++) {
                //System.out.println(commands[i]); //***check to see if parsing/split worked***
                list.add(commands[i]);

            }
          //  System.out.print(list); //***check to see if list was added correctly***
            history.addAll(list);
            try {
                //display history of shell with index
                if (list.get(list.size() - 1).equals("history")) {
                    int index = 1;
                    for (String s : history)
                        System.out.println((index++) + " " + s);
                    continue;
                }

                // Specific Commands.

                // ids
                if (list.contains("ids")) {
                    String results = webber.get_ids();
                    if(list.size()>1){
                        if(results.contains(list.get(1))){
                            String[] accountinfo = results.split("},\\{");
                            String userId = "";
                            for (String el : accountinfo) {
                                if (el.contains(list.get(1))){
                                int start = el.indexOf("userid");
                                int end = el.lastIndexOf("\"");
                                userId=el.substring(start+9, end);}}
                            Ids id = new Ids(userId,list.get(1),list.get(2));
                            webber.replace_id(id);
                            System.out.println("You have updated " + list.get(1) + "'s account");
                        } else {
                        Ids id = new Ids("-",list.get(1),list.get(2));
                        webber.create_id(id);
                        System.out.println("New account created! Github :"+ list.get(1) +" Username :" + list.get(2) +" was added to Under A Rock");}
                    }
                    else {SimpleShell.prettyPrint(results);}
                    continue;
                }

                // messages
                if (list.contains("messages")) {
                    if(list.size()>1){
                        String message = commandLine.substring((list.get(0).length()+list.get(1).length()+list.get(2).length())+1);
                        Messages messageObj = new Messages(list.get(1), list.get(2), message);
                        String result = webber.create_message(messageObj);
                        System.out.println(result);
                    } else {
                    String results = webber.get_messages();
                    SimpleShell.prettyPrint(results);}
                    continue;
                }


                //!! command returns the last command in history
                if (list.get(list.size() - 1).equals("!!")) {
                    pb.command(history.get(history.size() - 2));

                }//!<integer value i> command
                else if (list.get(list.size() - 1).charAt(0) == '!') {
                    int b = Character.getNumericValue(list.get(list.size() - 1).charAt(1));
                    if (b <= history.size())//check if integer entered isn't bigger than history size
                        pb.command(history.get(b));
                } else {
                    pb.command(list);
                }

                // wait, wait, what curiousness is this?
                Process process = pb.start();

                //obtain the input stream
                InputStream is = process.getInputStream();
                InputStreamReader isr = new InputStreamReader(is);
                BufferedReader br = new BufferedReader(isr);

                //read output of the process
                String line;
                while ((line = br.readLine()) != null)
                    System.out.println(line);
                br.close();


            }

            //catch ioexception, output appropriate message, resume waiting for input
            catch (IOException e) {
                System.out.println("Input Error, Please try again!");
            }
            // So what, do you suppose, is the meaning of this comment?
            /** The steps are:
             * 1. parse the input to obtain the command and any parameters
             * 2. create a ProcessBuilder object
             * 3. start the process
             * 4. obtain the output stream
             * 5. output the contents returned by the command
             */

        }


    }

}